Module java.xml.crypto
Package javax.xml.crypto.dsig

# Interface SignedInfo

All Superinterfaces:
  `XMLStructure`

public interface SignedInfo extends XMLStructure
An representation of the XML `SignedInfo` element as defined in the W3C Recommendation for XML-Signature Syntax and Processing. The XML Schema Definition is defined as:

     <element name="SignedInfo" type="ds:SignedInfoType"/>
     <complexType name="SignedInfoType">
       <sequence>
         <element ref="ds:CanonicalizationMethod"/>
         <element ref="ds:SignatureMethod"/>
         <element ref="ds:Reference" maxOccurs="unbounded"/>
       </sequence>
       <attribute name="Id" type="ID" use="optional"/>
     </complexType>

A `SignedInfo` instance may be created by invoking one of the `newSignedInfo` methods of the `XMLSignatureFactory` class.

Since:
  1.6
See Also:
  - `XMLSignatureFactory.newSignedInfo(CanonicalizationMethod, SignatureMethod, List)`
  - `XMLSignatureFactory.newSignedInfo(CanonicalizationMethod, SignatureMethod, List, String)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `CanonicalizationMethod`
  `getCanonicalizationMethod()`
  Returns the canonicalization method of this `SignedInfo`.
  `InputStream`
  `getCanonicalizedData()`
  Returns the canonicalized signed info bytes after a signing or validation operation.
  `String`
  `getId()`
  Returns the optional `Id` attribute of this `SignedInfo`.
  `List<Reference>`
  `getReferences()`
  Returns an `unmodifiable list` of one or more `Reference`s.
  `SignatureMethod`
  `getSignatureMethod()`
  Returns the signature method of this `SignedInfo`.

  ### Methods declared in interface javax.xml.crypto.XMLStructure

  `isFeatureSupported`

- ## Method Details

  - ### getCanonicalizationMethod

    CanonicalizationMethod getCanonicalizationMethod()
    Returns the canonicalization method of this `SignedInfo`.
    Returns:
      the canonicalization method

  - ### getSignatureMethod

    SignatureMethod getSignatureMethod()
    Returns the signature method of this `SignedInfo`.
    Returns:
      the signature method

  - ### getReferences

    List<Reference> getReferences()
    Returns an `unmodifiable list` of one or more `Reference`s.
    Returns:
      an unmodifiable list of one or more `Reference`s

  - ### getId

    String getId()
    Returns the optional `Id` attribute of this `SignedInfo`.
    Returns:
      the id (may be `null` if not specified)

  - ### getCanonicalizedData

    InputStream getCanonicalizedData()
    Returns the canonicalized signed info bytes after a signing or validation operation. This method is useful for debugging.
    Returns:
      an `InputStream` containing the canonicalized bytes, or `null` if this `SignedInfo` has not been signed or validated yet